import numpy as np
from utilities import distance_metrics as distances


def linear_kernel(x, y):
    return np.inner(x, y)


def polynomial_kernel(x, y, dimension=1.0, offset=0.0):
    return (offset + np.dot(x, y)) ** dimension


def gaussian_kernel(x, y, sigma=1.0):
    return np.exp(-np.sqrt(np.linalg.norm(x - y) ** 2 / (2 * sigma ** 2)))


def radial_kernel(x, y, gamma=1.0):
    return np.exp(-gamma * (distances.euclidean_distance(x, y) ** 2))